Index: irmp.c
===================================================================
--- irmp.c	(Revision 191)
+++ irmp.c	(Arbeitskopie)
@@ -4309,190 +4333,193 @@ irmp_ISR (void)
                         else
 #endif
 #if IRMP_SUPPORT_MANCHESTER == 1
-                        if ((irmp_param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER) &&
-                            irmp_pause_time >= 2 * irmp_param.pause_1_len_max && irmp_bit >= irmp_param.complete_len - 2 && !irmp_param.stop_bit)
+                        if ((ir->param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER) &&
+                            ir->isr.pause_time >= 2 * ir->param.pause_1_len_max && ir->bit >= ir->param.complete_len - 2 && !ir->param.stop_bit)
                         {                                                       // special manchester decoder
                             got_light = TRUE;                                   // this is a lie, but generates a stop bit ;-)
-                            irmp_param.stop_bit = TRUE;                         // set flag
+                            ir->param.stop_bit = TRUE;                         // set flag
                         }
                         else
 #endif // IRMP_SUPPORT_MANCHESTER == 1
-                        if (irmp_pause_time > IRMP_TIMEOUT_LEN)                 // timeout?
+                        if (ir->isr.pause_time > IRMP_TIMEOUT_LEN)                 // timeout?
                         {                                                       // yes...
-                            if (irmp_bit == irmp_param.complete_len - 1 && irmp_param.stop_bit == 0)
+                            if (ir->bit == ir->param.complete_len - 1 && ir->param.stop_bit == 0)
                             {
-                                irmp_bit++;
+                                ir->bit++;
                             }
 #if IRMP_SUPPORT_NEC_PROTOCOL == 1
-                            else if ((irmp_param.protocol == IRMP_NEC_PROTOCOL || irmp_param.protocol == IRMP_NEC42_PROTOCOL) && irmp_bit == 0)
+                            else if ((ir->param.protocol == IRMP_NEC_PROTOCOL
+                                      || ir->param.protocol == IRMP_NEC42_PROTOCOL)
+                                     && ir->bit == 0)
                             {                                                               // it was a non-standard repetition frame
 #ifdef ANALYZE                                                                              // with 4500us pause instead of 2250us
                                 ANALYZE_PRINTF ("Detected non-standard repetition frame, switching to NEC repetition\n");
 #endif // ANALYZE
-                                if (key_repetition_len < NEC_FRAME_REPEAT_PAUSE_LEN_MAX)
+                                if (ir->isr.key_repetition_len < NEC_FRAME_REPEAT_PAUSE_LEN_MAX)
                                 {
-                                    irmp_param.stop_bit     = TRUE;                         // set flag
-                                    irmp_param.protocol     = IRMP_NEC_PROTOCOL;            // switch protocol
-                                    irmp_param.complete_len = irmp_bit;                     // patch length: 16 or 17
-                                    irmp_tmp_address = last_irmp_address;                   // address is last address
-                                    irmp_tmp_command = last_irmp_command;                   // command is last command
-                                    irmp_flags |= IRMP_FLAG_REPETITION;
-                                    key_repetition_len = 0;
+                                    ir->param.stop_bit     = TRUE;                         // set flag
+                                    ir->param.protocol     = IRMP_NEC_PROTOCOL;            // switch protocol
+                                    ir->param.complete_len = ir->bit;                     // patch length: 16 or 17
+                                    ir->tmp_address = last_irmp_address;                   // address is last address
+                                    ir->tmp_command = last_irmp_command;                   // command is last command
+                                    ir->flags |= IRMP_FLAG_REPETITION;
+                                    ir->isr.key_repetition_len = 0;
                                 }
                                 else
                                 {
 #ifdef ANALYZE
-                                    ANALYZE_PRINTF ("ignoring NEC repetition frame: timeout occured, key_repetition_len = %d > %d\n",
-                                                    key_repetition_len, NEC_FRAME_REPEAT_PAUSE_LEN_MAX);
+                                    ANALYZE_PRINTF ("ignoring NEC repetition frame: timeout occured, ir->isr.key_repetition_len = %d > %d\n",
+                                                    ir->isr.key_repetition_len, NEC_FRAME_REPEAT_PAUSE_LEN_MAX);
 #endif // ANALYZE
-                                    irmp_ir_detected = FALSE;
+                                    ir->ir_detected = FALSE;
                                 }
                             }
 #endif // IRMP_SUPPORT_NEC_PROTOCOL == 1
 #if IRMP_SUPPORT_JVC_PROTOCOL == 1
-                            else if (irmp_param.protocol == IRMP_NEC_PROTOCOL && (irmp_bit == 16 || irmp_bit == 17))      // it was a JVC stop bit
+                            else if (ir->param.protocol == IRMP_NEC_PROTOCOL
+                                     && (ir->bit == 16 || ir->bit == 17))      // it was a JVC stop bit
                             {
 #ifdef ANALYZE
-                                ANALYZE_PRINTF ("Switching to JVC protocol, irmp_bit = %d\n", irmp_bit);
+                                ANALYZE_PRINTF ("Switching to JVC protocol, ir->bit = %d\n", ir->bit);
 #endif // ANALYZE
-                                irmp_param.stop_bit     = TRUE;                                     // set flag
-                                irmp_param.protocol     = IRMP_JVC_PROTOCOL;                        // switch protocol
-                                irmp_param.complete_len = irmp_bit;                                 // patch length: 16 or 17
-                                irmp_tmp_command        = (irmp_tmp_address >> 4);                  // set command: upper 12 bits are command bits
-                                irmp_tmp_address        = irmp_tmp_address & 0x000F;                // lower 4 bits are address bits
-                                irmp_start_bit_detected = 1;                                        // tricky: don't wait for another start bit...
+                                ir->param.stop_bit     = TRUE;                                     // set flag
+                                ir->param.protocol     = IRMP_JVC_PROTOCOL;                        // switch protocol
+                                ir->param.complete_len = ir->bit;                                 // patch length: 16 or 17
+                                ir->tmp_command        = (ir->tmp_address >> 4);                  // set command: upper 12 bits are command bits
+                                ir->tmp_address        = ir->tmp_address & 0x000F;                // lower 4 bits are address bits
+                                ir->isr.start_bit_detected = 1;                                        // tricky: don't wait for another start bit...
                             }
 #endif // IRMP_SUPPORT_JVC_PROTOCOL == 1
 #if IRMP_SUPPORT_LGAIR_PROTOCOL == 1
-                            else if (irmp_param.protocol == IRMP_NEC_PROTOCOL && (irmp_bit == 28 || irmp_bit == 29))      // it was a LGAIR stop bit
+                            else if (ir->param.protocol == IRMP_NEC_PROTOCOL && (ir->bit == 28 || ir->bit == 29))      // it was a LGAIR stop bit
                             {
 #ifdef ANALYZE
-                                ANALYZE_PRINTF ("Switching to LGAIR protocol, irmp_bit = %d\n", irmp_bit);
+                                ANALYZE_PRINTF ("Switching to LGAIR protocol, ir->bit = %d\n", ir->bit);
 #endif // ANALYZE
-                                irmp_param.stop_bit     = TRUE;                                     // set flag
-                                irmp_param.protocol     = IRMP_LGAIR_PROTOCOL;                      // switch protocol
-                                irmp_param.complete_len = irmp_bit;                                 // patch length: 16 or 17
-                                irmp_tmp_command        = irmp_lgair_command;                       // set command: upper 8 bits are command bits
-                                irmp_tmp_address        = irmp_lgair_address;                       // lower 4 bits are address bits
-                                irmp_start_bit_detected = 1;                                        // tricky: don't wait for another start bit...
+                                ir->param.stop_bit     = TRUE;                                     // set flag
+                                ir->param.protocol     = IRMP_LGAIR_PROTOCOL;                      // switch protocol
+                                ir->param.complete_len = ir->bit;                                 // patch length: 16 or 17
+                                ir->tmp_command        = ir->lgair_command;                       // set command: upper 8 bits are command bits
+                                ir->tmp_address        = ir->lgair_address;                       // lower 4 bits are address bits
+                                ir->isr.start_bit_detected = 1;                                        // tricky: don't wait for another start bit...
                             }
 #endif // IRMP_SUPPORT_LGAIR_PROTOCOL == 1
 
 #if IRMP_SUPPORT_NEC42_PROTOCOL == 1
 #if IRMP_SUPPORT_NEC_PROTOCOL == 1
-                            else if (irmp_param.protocol == IRMP_NEC42_PROTOCOL && irmp_bit == 32)      // it was a NEC stop bit
+                            else if (ir->param.protocol == IRMP_NEC42_PROTOCOL && ir->bit == 32)      // it was a NEC stop bit
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("Switching to NEC protocol\n");
 #endif // ANALYZE
-                                irmp_param.stop_bit     = TRUE;                                     // set flag
-                                irmp_param.protocol     = IRMP_NEC_PROTOCOL;                        // switch protocol
-                                irmp_param.complete_len = irmp_bit;                                 // patch length: 16 or 17
+                                ir->param.stop_bit     = TRUE;                                     // set flag
+                                ir->param.protocol     = IRMP_NEC_PROTOCOL;                        // switch protocol
+                                ir->param.complete_len = ir->bit;                                 // patch length: 16 or 17
 
                                 //        0123456789ABC0123456789ABC0123456701234567
                                 // NEC42: AAAAAAAAAAAAAaaaaaaaaaaaaaCCCCCCCCcccccccc
                                 // NEC:   AAAAAAAAaaaaaaaaCCCCCCCCcccccccc
-                                irmp_tmp_address        |= (irmp_tmp_address2 & 0x0007) << 13;      // fm 2012-02-13: 12 -> 13
-                                irmp_tmp_command        = (irmp_tmp_address2 >> 3) | (irmp_tmp_command << 10);
+                                ir->tmp_address        |= (ir->tmp_address2 & 0x0007) << 13;      // fm 2012-02-13: 12 -> 13
+                                ir->tmp_command        = (ir->tmp_address2 >> 3) | (ir->tmp_command << 10);
                             }
 #endif // IRMP_SUPPORT_NEC_PROTOCOL == 1
 #if IRMP_SUPPORT_LGAIR_PROTOCOL == 1
-                            else if (irmp_param.protocol == IRMP_NEC42_PROTOCOL && irmp_bit == 28)      // it was a NEC stop bit
+                            else if (ir->param.protocol == IRMP_NEC42_PROTOCOL && ir->bit == 28)      // it was a NEC stop bit
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("Switching to LGAIR protocol\n");
 #endif // ANALYZE
-                                irmp_param.stop_bit     = TRUE;                                     // set flag
-                                irmp_param.protocol     = IRMP_LGAIR_PROTOCOL;                      // switch protocol
-                                irmp_param.complete_len = irmp_bit;                                 // patch length: 16 or 17
-                                irmp_tmp_address        = irmp_lgair_address;
-                                irmp_tmp_command        = irmp_lgair_command;
+                                ir->param.stop_bit     = TRUE;                                     // set flag
+                                ir->param.protocol     = IRMP_LGAIR_PROTOCOL;                      // switch protocol
+                                ir->param.complete_len = ir->bit;                                 // patch length: 16 or 17
+                                ir->tmp_address        = ir->lgair_address;
+                                ir->tmp_command        = ir->lgair_command;
                             }
 #endif // IRMP_SUPPORT_LGAIR_PROTOCOL == 1
 #if IRMP_SUPPORT_JVC_PROTOCOL == 1
-                            else if (irmp_param.protocol == IRMP_NEC42_PROTOCOL && (irmp_bit == 16 || irmp_bit == 17))  // it was a JVC stop bit
+                            else if (ir->param.protocol == IRMP_NEC42_PROTOCOL && (ir->bit == 16 || ir->bit == 17))  // it was a JVC stop bit
                             {
 #ifdef ANALYZE
-                                ANALYZE_PRINTF ("Switching to JVC protocol, irmp_bit = %d\n", irmp_bit);
+                                ANALYZE_PRINTF ("Switching to JVC protocol, ir->bit = %d\n", ir->bit);
 #endif // ANALYZE
-                                irmp_param.stop_bit     = TRUE;                                     // set flag
-                                irmp_param.protocol     = IRMP_JVC_PROTOCOL;                        // switch protocol
-                                irmp_param.complete_len = irmp_bit;                                 // patch length: 16 or 17
+                                ir->param.stop_bit     = TRUE;                                     // set flag
+                                ir->param.protocol     = IRMP_JVC_PROTOCOL;                        // switch protocol
+                                ir->param.complete_len = ir->bit;                                 // patch length: 16 or 17
 
                                 //        0123456789ABC0123456789ABC0123456701234567
                                 // NEC42: AAAAAAAAAAAAAaaaaaaaaaaaaaCCCCCCCCcccccccc
                                 // JVC:   AAAACCCCCCCCCCCC
-                                irmp_tmp_command        = (irmp_tmp_address >> 4) | (irmp_tmp_address2 << 9);   // set command: upper 12 bits are command bits
-                                irmp_tmp_address        = irmp_tmp_address & 0x000F;                            // lower 4 bits are address bits
+                                ir->tmp_command        = (ir->tmp_address >> 4) | (ir->tmp_address2 << 9);   // set command: upper 12 bits are command bits
+                                ir->tmp_address        = ir->tmp_address & 0x000F;                            // lower 4 bits are address bits
                             }
 #endif // IRMP_SUPPORT_JVC_PROTOCOL == 1
 #endif // IRMP_SUPPORT_NEC42_PROTOCOL == 1
 
 #if IRMP_SUPPORT_SAMSUNG48_PROTOCOL == 1
-                            else if (irmp_param.protocol == IRMP_SAMSUNG48_PROTOCOL && irmp_bit == 32)          // it was a SAMSUNG32 stop bit
+                            else if (ir->param.protocol == IRMP_SAMSUNG48_PROTOCOL && ir->bit == 32)          // it was a SAMSUNG32 stop bit
                             {
 #ifdef ANALYZE
                                 ANALYZE_PRINTF ("Switching to SAMSUNG32 protocol\n");
 #endif // ANALYZE
-                                irmp_param.protocol         = IRMP_SAMSUNG32_PROTOCOL;
-                                irmp_param.command_offset   = SAMSUNG32_COMMAND_OFFSET;
-                                irmp_param.command_end      = SAMSUNG32_COMMAND_OFFSET + SAMSUNG32_COMMAND_LEN;
-                                irmp_param.complete_len     = SAMSUNG32_COMPLETE_DATA_LEN;
+                                ir->param.protocol         = IRMP_SAMSUNG32_PROTOCOL;
+                                ir->param.command_offset   = SAMSUNG32_COMMAND_OFFSET;
+                                ir->param.command_end      = SAMSUNG32_COMMAND_OFFSET + SAMSUNG32_COMMAND_LEN;
+                                ir->param.complete_len     = SAMSUNG32_COMPLETE_DATA_LEN;
                             }
 #endif // IRMP_SUPPORT_SAMSUNG_PROTOCOL == 1
 
 #if IRMP_SUPPORT_RCMM_PROTOCOL == 1
-                            else if (irmp_param.protocol == IRMP_RCMM32_PROTOCOL && (irmp_bit == 12 || irmp_bit == 24))  // it was a RCMM stop bit
+                            else if (ir->param.protocol == IRMP_RCMM32_PROTOCOL && (ir->bit == 12 || ir->bit == 24))  // it was a RCMM stop bit
                             {
-                                if (irmp_bit == 12)
+                                if (ir->bit == 12)
                                 {
-                                    irmp_tmp_command = (irmp_tmp_address & 0xFF);                   // set command: lower 8 bits are command bits
-                                    irmp_tmp_address >>= 8;                                         // upper 4 bits are address bits
+                                    ir->tmp_command = (ir->tmp_address & 0xFF);                   // set command: lower 8 bits are command bits
+                                    ir->tmp_address >>= 8;                                         // upper 4 bits are address bits
 
 #ifdef ANALYZE
-                                    ANALYZE_PRINTF ("Switching to RCMM12 protocol, irmp_bit = %d\n", irmp_bit);
+                                    ANALYZE_PRINTF ("Switching to RCMM12 protocol, ir->bit = %d\n", ir->bit);
 #endif // ANALYZE
-                                    irmp_param.protocol     = IRMP_RCMM12_PROTOCOL;                 // switch protocol
+                                    ir->param.protocol     = IRMP_RCMM12_PROTOCOL;                 // switch protocol
                                 }
-                                else // if ((irmp_bit == 24)
+                                else // if ((ir->bit == 24)
                                 {
 #ifdef ANALYZE
-                                    ANALYZE_PRINTF ("Switching to RCMM24 protocol, irmp_bit = %d\n", irmp_bit);
+                                    ANALYZE_PRINTF ("Switching to RCMM24 protocol, ir->bit = %d\n", ir->bit);
 #endif // ANALYZE
-                                    irmp_param.protocol     = IRMP_RCMM24_PROTOCOL;                 // switch protocol
+                                    ir->param.protocol     = IRMP_RCMM24_PROTOCOL;                 // switch protocol
                                 }
-                                irmp_param.stop_bit     = TRUE;                                     // set flag
-                                irmp_param.complete_len = irmp_bit;                                 // patch length
+                                ir->param.stop_bit     = TRUE;                                     // set flag
+                                ir->param.complete_len = ir->bit;                                 // patch length
                             }
 #endif // IRMP_SUPPORT_RCMM_PROTOCOL == 1
 
 #if IRMP_SUPPORT_TECHNICS_PROTOCOL == 1
-                            else if (irmp_param.protocol == IRMP_MATSUSHITA_PROTOCOL && irmp_bit == 22)  // it was a TECHNICS stop bit
+                            else if (ir->param.protocol == IRMP_MATSUSHITA_PROTOCOL && ir->bit == 22)  // it was a TECHNICS stop bit
                             {
 #ifdef ANALYZE
-                                ANALYZE_PRINTF ("Switching to TECHNICS protocol, irmp_bit = %d\n", irmp_bit);
+                                ANALYZE_PRINTF ("Switching to TECHNICS protocol, ir->bit = %d\n", ir->bit);
 #endif // ANALYZE
                                 // Situation:
-                                // The first 12 bits have been stored in irmp_tmp_command (LSB first)
-                                // The following 10 bits have been stored in irmp_tmp_address (LSB first)
+                                // The first 12 bits have been stored in ir->tmp_command (LSB first)
+                                // The following 10 bits have been stored in ir->tmp_address (LSB first)
                                 // The code of TECHNICS is:
                                 //   cccccccccccCCCCCCCCCCC (11 times c and 11 times C)
                                 //   ccccccccccccaaaaaaaaaa
                                 // where C is inverted value of c
 
-                                irmp_tmp_address <<= 1;
-                                if (irmp_tmp_command & (1<<11))
+                                ir->tmp_address <<= 1;
+                                if (ir->tmp_command & (1<<11))
                                 {
-                                    irmp_tmp_address |= 1;
-                                    irmp_tmp_command &= ~(1<<11);
+                                    ir->tmp_address |= 1;
+                                    ir->tmp_command &= ~(1<<11);
                                 }
 
-                                if (irmp_tmp_command == ((~irmp_tmp_address) & 0x07FF))
+                                if (ir->tmp_command == ((~ir->tmp_address) & 0x07FF))
                                 {
-                                    irmp_tmp_address = 0;
+                                    ir->tmp_address = 0;
 
-                                    irmp_param.protocol     = IRMP_TECHNICS_PROTOCOL;                   // switch protocol
-                                    irmp_param.complete_len = irmp_bit;                                 // patch length
+                                    ir->param.protocol     = IRMP_TECHNICS_PROTOCOL;                   // switch protocol
+                                    ir->param.complete_len = ir->bit;                                 // patch length
                                 }
                                 else
                                 {
@@ -4500,21 +4527,21 @@ irmp_ISR (void)
                                     ANALYZE_PRINTF ("error 8: TECHNICS frame error\n");
                                     ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
-                                    irmp_start_bit_detected = 0;                    // wait for another start bit...
-                                    irmp_pulse_time         = 0;
-                                    irmp_pause_time         = 0;
+                                    ir->isr.start_bit_detected = 0;                    // wait for another start bit...
+                                    ir->isr.pulse_time         = 0;
+                                    ir->isr.pause_time         = 0;
                                 }
                             }
 #endif // IRMP_SUPPORT_TECHNICS_PROTOCOL == 1
                             else
                             {
 #ifdef ANALYZE
-                                ANALYZE_PRINTF ("error 2: pause %d after data bit %d too long\n", irmp_pause_time, irmp_bit);
+                                ANALYZE_PRINTF ("error 2: pause %d after data bit %d too long\n", ir->isr.pause_time, ir->bit);
                                 ANALYZE_ONLY_NORMAL_PUTCHAR ('\n');
 #endif // ANALYZE
-                                irmp_start_bit_detected = 0;                    // wait for another start bit...
-                                irmp_pulse_time         = 0;
-                                irmp_pause_time         = 0;
+                                ir->isr.start_bit_detected = 0;                    // wait for another start bit...
+                                ir->isr.pulse_time         = 0;
+                                ir->isr.pause_time         = 0;
                             }
                         }
                     }
@@ -4527,37 +4554,37 @@ irmp_ISR (void)
                 if (got_light)
                 {
 #ifdef ANALYZE
-                    ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, irmp_bit, irmp_pulse_time, irmp_pause_time);
+                    ANALYZE_PRINTF ("%8.3fms [bit %2d: pulse = %3d, pause = %3d] ", (double) (time_counter * 1000) / F_INTERRUPTS, ir->bit, ir->isr.pulse_time, ir->isr.pause_time);
 #endif // ANALYZE
 
 #if IRMP_SUPPORT_MANCHESTER == 1
-                    if ((irmp_param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER))                                     // Manchester
+                    if ((ir->param.flags & IRMP_PARAM_FLAG_IS_MANCHESTER))                                     // Manchester
                     {
 #if IRMP_SUPPORT_MERLIN_PROTOCOL == 1
-                        if (irmp_param.complete_len == irmp_bit && irmp_param.protocol == IRMP_MERLIN_PROTOCOL)
+                        if (ir->param.complete_len == ir->bit && ir->param.protocol == IRMP_MERLIN_PROTOCOL)
                         {
                             if (last_value == 0)
                             {
-                                if (irmp_pulse_time >= 2 * irmp_param.pulse_1_len_min && irmp_pulse_time <= 2 * irmp_param.pulse_1_len_max &&
-                                    last_pause >= irmp_param.pause_1_len_min && last_pause <= irmp_param.pulse_1_len_max)
+                                if (ir->isr.pulse_time >= 2 * ir->param.pulse_1_len_min && ir->isr.pulse_time <= 2 * ir->param.pulse_1_len_max &&
+                                    last_pause >= ir->param.pause_1_len_min && last_pause <= ir->param.pulse_1_len_max)
                                 {
-                                    irmp_param.complete_len += 2;
+                                    ir->param.complete_len += 2;
                                     irmp_store_bit(0);
                                     irmp_store_bit(1);
                                 }
                             }
                             else
                             {
-                                if (last_pause >= 2 * irmp_param.pause_1_len_min && last_pause <= 2 * irmp_param.pulse_1_len_max)
+                                if (last_pause >= 2 * ir->param.pause_1_len_min && last_pause <= 2 * ir->param.pulse_1_len_max)
                                 {
-                                    if (irmp_pulse_time >= irmp_param.pulse_1_len_min && irmp_pulse_time <= irmp_param.pulse_1_len_max)
+                                    if (ir->isr.pulse_time >= ir->param.pulse_1_len_min && ir->isr.pulse_time <= ir->param.pulse_1_len_max)
                                     {
-                                        irmp_param.complete_len++;
+                                        ir->param.complete_len++;
                                         irmp_store_bit(0);
                                     }
-                                    else if (irmp_pulse_time >= 2 * irmp_param.pulse_1_len_min && irmp_pulse_time <= 2 * irmp_param.pulse_1_len_max)
+                                    else if (ir->isr.pulse_time >= 2 * ir->param.pulse_1_len_min && ir->isr.pulse_time <= 2 * ir->param.pulse_1_len_max)
                                     {
-                                        irmp_param.complete_len += 2;
+                                        ir->param.complete_len += 2;
                                         irmp_store_bit(0);
                                         irmp_store_bit(1);
                                     }
@@ -4567,19 +4594,19 @@ irmp_ISR (void)
                         else
 #endif
 #if 1
-                        if (irmp_pulse_time > irmp_param.pulse_1_len_max /* && irmp_pulse_time <= 2 * irmp_param.pulse_1_len_max */)
+                        if (ir->isr.pulse_time > ir->param.pulse_1_len_max /* && ir->isr.pulse_time <= 2 * ir->param.pulse_1_len_max */)
 #else // better, but some IR-RCs use asymmetric timings :-/
-                        if (irmp_pulse_time > irmp_param.pulse_1_len_max && irmp_pulse_time <= 2 * irmp_param.pulse_1_len_max &&
-                            irmp_pause_time <= 2 * irmp_param.pause_1_len_max)
+                        if (ir->isr.pulse_time > ir->param.pulse_1_len_max && ir->isr.pulse_time <= 2 * ir->param.pulse_1_len_max &&
+                            ir->isr.pause_time <= 2 * ir->param.pause_1_len_max)
 #endif
                         {
 #if IRMP_SUPPORT_RC6_PROTOCOL == 1
-                            if (irmp_param.protocol == IRMP_RC6_PROTOCOL && irmp_bit == 4 && irmp_pulse_time > RC6_TOGGLE_BIT_LEN_MIN)         // RC6 toggle bit
+                            if (ir->param.protocol == IRMP_RC6_PROTOCOL && ir->bit == 4 && ir->isr.pulse_time > RC6_TOGGLE_BIT_LEN_MIN)         // RC6 toggle bit
                             {
 #ifdef ANALYZE
                                 ANALYZE_PUTCHAR ('T');
 #endif // ANALYZE
-                                if (irmp_param.complete_len == RC6_COMPLETE_DATA_LEN_LONG)                      // RC6 mode 6A
+                                if (ir->param.complete_len == RC6_COMPLETE_DATA_LEN_LONG)                      // RC6 mode 6A
                                 {
                                     irmp_store_bit (1);
                                     last_value = 1;
@@ -4597,19 +4624,19 @@ irmp_ISR (void)
 #endif // IRMP_SUPPORT_RC6_PROTOCOL == 1
                             {
 #ifdef ANALYZE
-                                ANALYZE_PUTCHAR ((irmp_param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? '0' : '1');
+                                ANALYZE_PUTCHAR ((ir->param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? '0' : '1');
 #endif // ANALYZE
-                                irmp_store_bit ((irmp_param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 0  :  1 );
+                                irmp_store_bit ((ir->param.flags & IRMP_PARAM_FLAG_1ST_PULSE_IS_1) ? 0  :  1 );
 
 #if IRMP_SUPPORT_RC6_PROTOCOL == 1
-                                if (irmp_param.protocol == IRMP_RC6_PROTOCOL && irmp_bit == 4 && irmp_pulse_time > RC6_TOGGLE_BIT_LEN_MIN)      // RC6 toggle bit
+                                if (ir->param.protocol == IRMP_RC6_PROTOCOL && ir->bit == 4 && ir->isr.pulse_time > RC6_TOGGLE_BIT_LEN_MIN)      // RC6 toggle bit
                                 {
 #ifdef ANALYZE
                                     ANALYZE_PUTCHAR ('T');
 #endif // ANALYZE
                                     irmp_store_bit (1);
 
-                                    if (irmp_pause_time > 2 * irmp_param.pause_1_len_max)
+                                    if (ir->isr.pause_time > 2 * ir->param.pause_1_len_max)
                                     {
                                         last_value = 0;
                                     }
